SystemOrganization addCategory: #'Spec-Tests'!

ComposableModel subclass: #TestingComposableModel
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!TestingComposableModel commentStamp: '<historical>' prior: 0!
A TestingComposableModel is a stupid composable model used to test SpecInterpreter!

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 12/12/2012 14:28'!
defaultSpec
	<spec>

	^ SpecLayout composed
		add: #list;
		yourself! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 5/22/2012 15:05'!
testingSpec

	^ {#Text.
		#model:.	#model}.! !

!TestingComposableModel class methodsFor: 'specs' stamp: ''!
title

	^ 'You should not see me !!'! !

!TestingComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 12/12/2012 14:28'!
initializeWidgets 

	self instantiateModels: #(list ListComposableModel)! !

!TestingComposableModel methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 12/12/2012 14:29'!
list

	^ list! !

TestCase subclass: #SpecInterpreterTest
	instanceVariableNames: 'specInterpreter specInterpreterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!SpecInterpreterTest commentStamp: '<historical>' prior: 0!
A SpecInterpreterTest is a test class for testing the behavior of SpecInterpreter!

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 10/18/2012 15:27'!
setUp
	"Setting up code for SpecInterpreterTest"

	specInterpreterClass := SpecInterpreter.
	specInterpreter := specInterpreterClass new.
	specInterpreter model: TestingComposableModel new! !

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 10/18/2012 15:24'!
tearDown
	"Tearing down code for SpecInterpreterTest"

	specInterpreterClass resetBinding.
	specInterpreterClass := nil.
	specInterpreter := nil.! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 10/18/2012 15:41'!
testBindings

	self assert: specInterpreter bindings bindings class equals: MorphicBindings.
	specInterpreterClass bindings: MorphicBindingsWithSplitters new.
	self assert: specInterpreter bindings bindings class equals: MorphicBindingsWithSplitters.
	
	specInterpreterClass buildWidgetFor: TestingComposableModel new.
	self assert: specInterpreter bindings bindings class equals: MorphicBindings.! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 12/12/2012 14:30'!
testBuildWidgetFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreterClass buildWidgetFor: model withSpec: #testingSpec.
	
	self assert: (morph model == model).
	self assert: (model widget class = PluggableTextMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 10/18/2012 15:33'!
testBuildWidgetForWithSpec

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreterClass buildWidgetFor: model withSpec: #testingSpec.
	
	self assert: (morph model == model).
	self assert: (model widget class = PluggableTextMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 12/12/2012 14:30'!
testBuildWindowFor

	| model widget |
	model := TestingComposableModel new.
	widget := specInterpreterClass buildWindowFor: model.
	
	self assert: ( model widget = widget).
	self assert: (widget submorphs anySatisfy: [:e | e class = PanelMorph ])! !

!SpecInterpreterTest methodsFor: 'tests' stamp: ''!
testConvertRandomSymbolOfClassToInstance
	
	| symbol instance |
	symbol := #PluggableListMorph.
	
	instance := specInterpreter convertSymbolOfClassToInstance: symbol.
	self assert: (instance class name = symbol)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 10/18/2012 16:05'!
testDynamicBuild

	| model widget1 widget2 widget3 |
	model := TestingComposableModel new.
	widget1 := specInterpreterClass buildWidgetFor: model.
	widget2 := specInterpreterClass buildWidgetFor: model.
	
	self deny: widget1 == widget2.
	
	model needRebuild: false.
	widget3 := specInterpreterClass buildWidgetFor: model.
	
	self assert: widget2 == widget3.
	self assert: model needRebuild! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 10/18/2012 15:26'!
testInterpretASpecModelMorphAssociation

	| spec model morph |
	model := DummyComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreterClass interpretASpec: spec model: model.
	
	self assert: (model widget == morph).! !
